/****************************************************************************

**  Gcssamer - Lightweight CSS Inspector for Firefox

**  Copyright (c) 2008  Charles Melhorn

**

**  This file is part of Gcssamer.

**

**  Gcssamer is free software; you can redistribute it and/or modify

**  it under the terms of the GNU General Public License as published by

**  the Free Software Foundation; either version 2 of the License, or

**  (at your option) any later version.

**

**  Gcssamer is distributed in the hope that it will be useful,

**  but WITHOUT ANY WARRANTY; without even the implied warranty of

**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

**  GNU General Public License for more details.

**

**  You should have received a copy of the GNU General Public License

**  along with this program; if not, write to the Free Software

**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

**

**  Or see the GNU web site at: http://www.gnu.org

**

****************************************************************************/ 





var gGCSSAMERPrefService = Components.classes["@mozilla.org/preferences-service;1"]

                            .getService(Components.interfaces.nsIPrefService);

var nsIPrefBranch = Components.interfaces.nsIPrefBranch;




const gGCSSAMERUserPrefUtils = 

{

  prefNode:       gGCSSAMERPrefService.getBranch("extensions.gcssamer."),



  getPref:        function(prefId_str)

  {

    var type = this.prefNode.getPrefType(prefId_str);
    try {
      if (type == nsIPrefBranch.PREF_STRING) {
        return this.prefNode.getComplexValue(prefId_str, Components.interfaces.nsISupportsString).data;
      } else if (type == nsIPrefBranch.PREF_BOOL) {
        return this.prefNode.getBoolPref(prefId_str);
      } else if (type == nsIPrefBranch.PREF_INT) {
        return this.prefNode.getIntPref(prefId_str);
      }
    } catch(ex) {
      debug("ERROR: Unable to read pref \"" + prefId_str + "\".\n");
    }
    return null;
  },

  setPref:        function(prefId_str, aValue)
  {
    var type = this.prefNode.getPrefType(prefId_str);
    try {
      if (type == nsIPrefBranch.PREF_STRING)
       {
        var str = Components.classes["@mozilla.org/supports-string;1"]
                  .createInstance(Components.interfaces.nsISupportsString);
        str.data = aValue;
        this.prefNode.setComplexValue(prefId_str, Components.interfaces.nsISupportsString, str);
       }
      else if (type == nsIPrefBranch.PREF_BOOL)
       {
        this.prefNode.setBoolPref(prefId_str, aValue);
       }
      else if (type == nsIPrefBranch.PREF_INT)
       {
        this.prefNode.setIntPref(prefId_str, aValue);
       }
    } catch(ex) {
      debug("ERROR: Unable to read pref \"" + prefId_str + "\".\n");
    }
    return null;
  }

}